import java.awt.List;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

class Mravenec implements Comparable {
	int vzdalenost;
	int start;
	char smer;

	public Mravenec(int vzdalenost, char smer, int start) {
		this.start = start;
		this.vzdalenost = vzdalenost;
		this.smer = smer;
	}

	@Override
	public int compareTo(Object arg0) {
		if (arg0 instanceof Mravenec) {
			Mravenec obj = (Mravenec) arg0;

			if (this.vzdalenost > obj.vzdalenost) {
				return 1;
			} else {
				return -1;
			}
		}
		return 0;
	}
	
	@Override
	public String toString() {
		return "Mravenec: " + vzdalenost;
	}
}

public class Ants {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		int L = sc.nextInt();
		int A = sc.nextInt();
		
		//System.out.println(A);
		// Mravenec[] pole = new Mravenec[A];

		ArrayList<Mravenec> l = new ArrayList<Mravenec>(A);

				
		for (int i = 0; i < A; i++) {
			int pozice = sc.nextInt();
			
			char smer = sc.next().charAt(0);
			//System.out.println("Smer je " + smer);

			int vzdalenost;
			if (smer == 'R') {
				vzdalenost = L - pozice;
			} else {
				vzdalenost = pozice;
			}

			l.add(new Mravenec(vzdalenost, smer, pozice));
			
			
		}

		Collections.sort(l);
		
		//System.out.println(Arrays.toString(l.toArray()));
		
		
		if (l.size() == 1) {
			System.out.println("The last ant will fall down in " + l.get(0).vzdalenost + " seconds - " + "started at " + l.get(0).start + ".");
			return;
		}
		
		
		Mravenec posledniM = l.get(l.size()-1);
		Mravenec predposlM = l.get(l.size() - 2);
		
		if (posledniM.vzdalenost == predposlM.vzdalenost ) {
			String mravenci;
			if (posledniM.start > predposlM.start) {
				mravenci = "started at " + predposlM.start + " and " + posledniM.start + ".";
			} else {
				mravenci = "started at " + posledniM.start + " and " + predposlM.start + ".";
			}				
			System.out.println("The last ant will fall down in " + posledniM.vzdalenost + " seconds - " + mravenci); 
								
		} else {
			System.out.println("The last ant will fall down in " + posledniM.vzdalenost + " seconds - " + "started at " + posledniM.start + ".");
		}

	}

}
